# -*- coding: utf-8 -*-
from setuphelpers import *



def install():

    msi_files = glob.glob('EShareClient_*.msi')[0]

    uninstall_older_version()

    install_msi_if_needed(
        msi_files,
        name="^EShare$",
        min_version=control.get_software_version()
    )

def uninstall_older_version():
    for to_uninstall in installed_softwares(name="^EShare$"):
        if Version(to_uninstall["version"]) < Version(control.get_software_version()):
            print(f"Removing: {to_uninstall['name']} ({to_uninstall['version']})")
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])
            remove_tree(to_uninstall["install_location"], ignore_errors=True)
            uninstall()


def uninstall():
    # Remove residual uninstall key
    for virtual_monitor_assistant in installed_softwares(name="EShare Virtual Monitor Assistant|ESystemRemoteService"):
        folder_virtual_monitor_assistant = os.path.dirname(virtual_monitor_assistant['uninstall_string'])
        if isdir(folder_virtual_monitor_assistant):
            remove_tree(folder_virtual_monitor_assistant, ignore_errors=True)
        unregister_uninstall(virtual_monitor_assistant['key'])